class Move {
 private:
  Move* next;


  Move* getCur(int number);

  int append(int,int,bool,int);
  int howLongL(){if(nextL==0) return 1; return 1+nextL->howLongL();}

  void setListPrev(Move*);

 public:
  int x,y;
  int what;
  bool White;
  int nextNumber;
  char* comment;
  Move* prev;
  Move* nextL;


  Move* getNext();
  Move* setNext(Move*);
  Move* getFirstNext(){return next;};

  Move* nextAppend(int,int,bool,int, char* comm=0);
  Move* insertBeforeNext(int i,int j,bool whoseTurn, int what);
  int setLongestNext();

  bool hasNext(){ return (next!=0);};
  int howManyNexts() { if(next==0) return 0; return next->howLongL();}

  void setComm(char*);
  
  Move(int,int,bool,int);
  Move(int,int,bool,int, char*);
  Move(int,int,bool,int,Move*);
  Move(int,int,bool,int,Move*, char*);
  ~Move();
};


Move* Move::getNext(){
  if(next == 0) return 0;
  return next->getCur(nextNumber);
}

Move* Move::setNext(Move* n){
  next = n;
}

Move* Move::getCur(int number){
  if(number == 0) return this;
  if(nextL == 0) return 0;
  return nextL->getCur(number-1);
}

void Move::setListPrev(Move* pre){
  prev = pre;
  if(nextL != 0) nextL->setListPrev(pre);
}

Move* Move::insertBeforeNext(int i,int j,bool whoseTurn, int what){
  Move* save = next;
  next = new Move(i, j, whoseTurn, what, this);
  next -> next = save;
  save -> setListPrev(next);
  next -> nextNumber = nextNumber;
  nextNumber = 0;
  return next;
}


Move* Move::nextAppend(int i,int j, bool w,int k, char* comm){
  if(next == 0) {
    next = new Move(i,j,w,k, this, comm);
    return next;
  }
  else{
    nextNumber = next->append(i, j, w, k);
    return next->getCur(nextNumber);
  }
}

int Move::append(int i, int j, bool w, int k){
  if(x == i && y == j){
    White = w;
    what = k;
    return 0;
  }
  if(nextL == 0) {
    nextL = new Move(i, j, w, k, prev);
    return 1;
  }
  return 1 + (nextL->append(i,j,w,k));
}

int Move::setLongestNext(){
  if(next == 0) return 0;
  int max=0, in, number=0, inNumber =0;
  Move * nexts = next;
  while (nexts != 0){
    in = nexts->setLongestNext();
    if(in > max) {
      max = in;
      number = inNumber;
    }
    nexts = nexts->nextL;
    inNumber++;
  }
  nextNumber = number;
  return max+1;
}

void Move::setComm(char* comm){
  if(comm!=0){
    comment = new char[(strlen(comm)/MAXSTRING +1)*MAXSTRING];
    strcpy(comment, comm);
  }
  else comment=0;

}

Move::Move(int i, int j, bool w,int k){
  comment=0;
  x=i;
  y=j;
  White=w;
  what=k;
  prev=0;
  next = 0;
  nextL=0;
  nextNumber=0;
}

Move::Move(int i, int j, bool w,int k, char* comm){
  x=i;
  y=j;
  White=w;
  what=k;
  prev=0;
  next = 0;
  nextL=0;
  nextNumber=0;
  if(comm!=0){
    comment = new char[(strlen(comm)/MAXSTRING +1)*MAXSTRING];
    strcpy(comment, comm);
  }
  else comment=0;
}

Move::Move(int i, int j, bool w, int k, Move *a){
  comment=0;
  x=i;
  y=j;
  White=w;
  what=k;
  prev = a;
  next = 0;
  nextL=0;
  nextNumber=0;
}

Move::Move(int i, int j, bool w, int k, Move *a, char* comm){
  x=i;
  y=j;
  White=w;
  what=k;
  prev = a;
  next = 0;
  nextL=0;
  nextNumber=0;
  if(comm!=0){
    comment = new char[(strlen(comm)/MAXSTRING +1)*MAXSTRING];
    strcpy(comment, comm);
  }
  else comment=0;
}

Move::~Move(){
  if(comment!=0)
    delete comment;
  comment=0;
  if(next!=0)
    delete next;
  next = 0;
  if(prev!=0)
    prev->next = 0;
  delete nextL;
}

